<template>
  <v-app style="position: relative">
    <right-nav :is-open.sync="isRightNavOpen" />

    <v-btn
      v-if="$vuetify.breakpoint.mobile"
      absolute
      dark
      fab
      bottom
      right
      color="primary"
      style="bottom: 1em"
      @click.stop="isRightNavOpen = !isRightNavOpen"
    >
      <v-icon>mdi-menu</v-icon>
    </v-btn>

    <metrocheck-flash-alert
      v-for="v in alertVariants"
      :key="`alert-${v}`"
      :variant="v"
      class="mt-0"
      auto-hide
    />
    <v-main>
      <router-view />
    </v-main>
  </v-app>
</template>

<script>
  import RightNav from './RightNav'
  import { fetchAvailableDates as apiFetchAvailableDates } from '../api'
  import { actions, mutations } from '../store/constants'
  import { mapGetters, mapState } from 'vuex'
  import MetrocheckFlashAlert from './FlashAlert'
  import mapWorker from '../workers/positions'

  export default {
    name: 'App',

    components: {
      MetrocheckFlashAlert,
      RightNav,
    },

    data: function () {
      return {
        isRightNavOpen: null,
      }
    },

    computed: {
      ...mapState(['hydrated']),
      ...mapGetters(['getLinesCount', 'getPointsCount', 'getLinepointsCount']),
      alertVariants: () => ['info', 'success', 'warning', 'error'],
    },

    watch: {
      hydrated: async function () {
        if (!this.getLinesCount()) {
          await this.$store.dispatch('linesLoad')
        }
        if (!this.getPointsCount()) {
          await this.$store.dispatch('pointsLoad')
        }
        if (!this.getLinepointsCount()) {
          await this.$store.dispatch('linepointsLoad')
        }
      },
    },

    async created () {
      apiFetchAvailableDates()
        .then(allowedDates => this.$store.commit(mutations.SET_ALLOWED_DATES, allowedDates))
      return this.$store.dispatch(actions.FETCH_LINES_GEOJSON)
        .then(geojsonSources => {
          mapWorker.send({
            action: 'SET_GEOJSON_SOURCES',
            args: {
              geojsonSources: Object.fromEntries(geojsonSources.map(s => [s.index, s.data])),
            },
          }); return geojsonSources
        })
    },
  }
</script>
